/*
 * 
 *  dynamic linker command file
 *  generated: Tue Dec 10 00:08:26 2002

 *  kernel   : brickOS
 *  app start: 0xadfc
 * 
 *  BrickOS for LEGO(R) Mindstorms(TM)
 *  Originally: legOS - the independent LEGO Mindstorms OS
 *              (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x2dfc
  ram   : o = 0xadfc, l = 0x5100
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    _kmain = 0x0000 ;
    _mm_try_join = 0x00d8 ;
    _mm_defrag = 0x0116 ;
    _mm_update_first_free = 0x0154 ;
    _mm_init = 0x017a ;
    _malloc = 0x01f8 ;
    _free = 0x029e ;
    _calloc = 0x02c8 ;
    _mm_reaper = 0x0310 ;
    _mm_free_mem = 0x033e ;
    _clock_handler = 0x037c ;
    _subsystem_handler = 0x03a0 ;
    _task_switch_handler = 0x0406 ;
    _systime_tm_return = 0x0420 ;
    _systime_init = 0x0430 ;
    _systime_shutdown = 0x04a8 ;
    _systime_set_switcher = 0x04ba ;
    _systime_set_timeslice = 0x04c0 ;
    _tm_switcher = 0x04de ;
    _tm_scheduler = 0x04fa ;
    _yield = 0x0696 ;
    _tm_man_task = 0x06b4 ;
    _tm_battery_task = 0x06f8 ;
    _tm_init = 0x0740 ;
    _tm_start = 0x07ae ;
    _execi = 0x07c0 ;
    _exit = 0x0960 ;
    _wait_event = 0x0982 ;
    _msleep = 0x0a1e ;
    _sleep = 0x0a60 ;
    _shutdown_task = 0x0a84 ;
    _shutdown_tasks = 0x0a90 ;
    _kill = 0x0ae0 ;
    _killall = 0x0b1c ;
    _sem_event_wait = 0x0b9e ;
    _sem_wait = 0x0bb6 ;
    _sem_trywait = 0x0be6 ;
    _sem_post = 0x0bfe ;
    _delay = 0x0c0e ;
    _cputc_native = 0x0c2e ;
    _cputc_native_0 = 0x0c5c ;
    _cputc_native_1 = 0x0c90 ;
    _cputc_native_2 = 0x0cc6 ;
    _cputc_native_3 = 0x0d00 ;
    _cputc_native_4 = 0x0d3c ;
    _cputc_native_5 = 0x0d78 ;
    _cputw = 0x0d84 ;
    _cputs = 0x0dc8 ;
    _cls = 0x0e10 ;
    _lcd_number = 0x0e18 ;
    _lcd_refresh_next_byte = 0x0eb8 ;
    _lcd_refresh_next_byte_core = 0x0ecc ;
    _lcd_refresh = 0x0f1c ;
    _lcd_power_on = 0x0f4c ;
    _lcd_power_off = 0x0f5e ;
    _lcd_init = 0x0f7a ;
    _rx_handler = 0x0fc4 ;
    _rx_core = 0x0fd8 ;
    _rxerror_handler = 0x1044 ;
    _rxerror_core = 0x1058 ;
    _txend_handler = 0x109e ;
    _txend_core = 0x10b2 ;
    _tx_handler = 0x10c0 ;
    _tx_core = 0x10d4 ;
    _lnp_logical_shutdown = 0x10fc ;
    _lnp_logical_init = 0x111c ;
    _lnp_logical_write = 0x11d0 ;
    _lnp_integrity_write = 0x12a4 ;
    _lnp_addressing_write = 0x1306 ;
    _lnp_receive_packet = 0x139a ;
    _lnp_integrity_byte = 0x1418 ;
    _lnp_integrity_reset = 0x15f4 ;
    _lnp_integrity_reset_core = 0x1608 ;
    _lnp_timeout_reset = 0x1634 ;
    _lnp_timeout_reset_core = 0x1648 ;
    _lnp_init = 0x1652 ;
    _msg_received = 0x1674 ;
    _send_msg = 0x16da ;
    _lnp_integrity_active = 0x1738 ;
    _lnp_timeout_set = 0x1744 ;
    _lr_getdata = 0x174e ;
    _lr_process = 0x177a ;
    _lr_waitdata = 0x17ee ;
    _lr_thread = 0x1834 ;
    _lr_init = 0x1868 ;
    _lr_startup = 0x1872 ;
    _lr_shutdown = 0x18b6 ;
    _program_valid = 0x18ca ;
    _program_stop = 0x1c84 ;
    _key_handler = 0x1d00 ;
    _lrkey_handler = 0x1fac ;
    _program_init = 0x21d4 ;
    _program_shutdown = 0x2232 ;
    _vis_handler = 0x2240 ;
    _vis_core = 0x2254 ;
    _get_battery_mv = 0x22ae ;
    _shutoff_restart = 0x22d8 ;
    _shutoff_init = 0x22e8 ;
    _autoshutoff_check = 0x22f4 ;
    _autoshutoff_check_core = 0x2308 ;
    _dkey_handler = 0x2338 ;
    _dkey_pressed = 0x2376 ;
    _dkey_released = 0x2398 ;
    _getchar = 0x23b8 ;
    _dm_handler = 0x23e2 ;
    _dm_init = 0x2420 ;
    _dm_shutdown = 0x2424 ;
    _motor_a_dir = 0x2448 ;
    _motor_b_dir = 0x2486 ;
    _motor_c_dir = 0x24c8 ;
    _ds_rotation_set = 0x2508 ;
    _ds_rotation_handler = 0x255c ;
    _ds_init = 0x2654 ;
    _ds_shutdown = 0x268a ;
    _dsound_handler = 0x26a2 ;
    _dsound_core = 0x26b6 ;
    _dsound_init = 0x27ae ;
    _dsound_shutdown = 0x27c6 ;
    _dsound_stop = 0x27ca ;
    _dsound_finished = 0x27ea ;
    _locked_increment = 0x2804 ;
    _locked_decrement = 0x2814 ;
    _locked_check_and_increment = 0x2824 ;
    _wait_critical_section = 0x285e ;
    _enter_critical_section = 0x2880 ;
    _memset = 0x28ae ;
    _memcpy = 0x28bc ;
    ___mulhi3 = 0x28ce ;
    ___udivhi3 = 0x28de ;
    ___mulsi3 = 0x28f0 ;
    ___divsi3 = 0x290c ;
    _hex_display_codes = 0x294a ;
    _ascii_display_codes = 0x295a ;
    _lnp_rcx_header = 0x29ec ;
    _lnp_rcx_remote_op = 0x29ee ;
    _lnp_rcx_msg_op = 0x29f0 ;
    _min_length = 0x2a1a ;
    _dm_a_pattern = 0x2a4a ;
    _dm_b_pattern = 0x2a4e ;
    _dm_c_pattern = 0x2a52 ;
    _firmware_string = 0x2b34 ;
    _etext = 0x2b34 ;
    _lcd_refresh_period = 0x2b36 ;
    _lnp_hostaddr = 0x2b38 ;
    _lnp_timeout = 0x2b3a ;
    _lr_dataready = 0x2b3c ;
    _vis_refresh_counter = 0x2b3e ;
    _vis_refresh_period = 0x2b3f ;
    _battery_refresh_counter = 0x2b40 ;
    _battery_refresh_period = 0x2b42 ;
    _auto_shutoff_counter = 0x2b44 ;
    _auto_shutoff_period = 0x2b46 ;
    _auto_shutoff_secs = 0x2b48 ;
    _auto_shutoff_elapsed = 0x2b4a ;
    _idle_powerdown = 0x2b4c ;
    _dsound_system_sounds = 0x2b4e ;
    _bss_start = 0x2b50 ;
    __edata = 0x2b50 ;
    _mm_first_free = 0x2d3a ;
    _tm_timeslice = 0x2d3c ;
    _tm_current_slice = 0x2d3d ;
    _tm_switcher_vector = 0x2d3e ;
    _sys_time = 0x2d40 ;
    _ctid = 0x2d50 ;
    _td_single = 0x2d60 ;
    _nb_tasks = 0x2d74 ;
    _priority_head = 0x2d76 ;
    _nb_system_tasks = 0x2d78 ;
    _lcd_byte_counter = 0x2d7a ;
    _lcd_refresh_counter = 0x2d7b ;
    _tx_state = 0x2d7c ;
    _lnp_rcx_checksum = 0x2d80 ;
    _lnp_integrity_handler = 0x2d82 ;
    _lnp_rcx_message = 0x2d84 ;
    _lnp_rcx_temp1 = 0x2d85 ;
    _lnp_timeout_counter = 0x2d86 ;
    _lnp_addressing_handler = 0x2d90 ;
    _lnp_remote_handler = 0x2db0 ;
    _lnp_integrity_state = 0x2db2 ;
    _lnp_rcx_temp0 = 0x2db4 ;
    _lr_curkeys = 0x2db8 ;
    _lr_data = 0x2dba ;
    _EventType = 0x2dbc ;
    _lr_handler = 0x2dbe ;
    _lr_tid = 0x2dc0 ;
    _lr_timeoff = 0x2dc4 ;
    _packet_len = 0x2dc8 ;
    _cprog = 0x2dca ;
    _packet_src = 0x2dcc ;
    _dkey_timer = 0x2dce ;
    _dkey = 0x2dcf ;
    _dkey_multi = 0x2dd0 ;
    _dm_a = 0x2dd4 ;
    _dm_b = 0x2dd8 ;
    _dm_c = 0x2ddc ;
    _ds_rotation = 0x2de0 ;
    _ds_channel = 0x2de1 ;
    _ds_rotations = 0x2de4 ;
    _ds_activation = 0x2dea ;
    _dsound_next_note = 0x2dec ;
    _dsound_internote_ms = 0x2dee ;
    _dsound_16th_ms = 0x2df0 ;
    _dsound_next_time = 0x2df4 ;
    _kernel_critsec_count = 0x2df8 ;
    _end = 0x2dfa ;
    _mm_start = 0x2dfa ;
    /* end of kernel symbols */
  }  > kern
      
  .text BLOCK(2) :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */
    *(.persist)

    ___text_end = . ;
  }  > ram

  .tors BLOCK(2) : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data BLOCK(2) : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss BLOCK(2) : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > topram

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _WDT_CSR = 0xa8 ;
    _WDT_CNT = 0xa9 ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
